#!/usr/bin/env python
# (c) Simon Burton 2001
# this code is GPL licensed; see file LICENSE

#
#
# make a .c file from the .py file and see if it worked!

import string
import tempfile,os
import sys
try:
  fname=string.split(os.path.split(sys.argv[1])[1],".")[0]
  exec("import "+fname)
except IndexError:
  print "Call me with the name of the file h2py made."
  sys.exit(0)
module=eval(fname)

from types import *

def command(s):
  print s
  tmp=tempfile.mktemp()
  os.system(s+" > "+tmp)
  return open(tmp)

blist=[]
for name in dir(module):
  object=eval("module."+name)
  #if not callable(object) and not type(object)==ModuleType:
  if type(object)==IntType:
    blist.append((name,object))

cpath="temp.c"
cfile=open(cpath,"w+")
cfile.write(
   "#include <stdio.h>\n"\
  +"#include <"+fname+".h>\n"\
  +"int main()\n{  int i;\n")
for name,object in blist:
  cfile.write(
    "  i="+name+";\n  printf(\"%d\\n\",i);\n")
    #+"int main(){return "+name+";}\n"
cfile.write("  return 0;\n}\n")
cfile.close()

file=command("gcc "+cpath+" -I/usr/include/sys -o temp")
for line in file.readlines():
  print(line)
file.close()
file=command("./temp")
values=map(string.atoi,file.readlines())
file.close()
assert len(values)==len(blist)
for i in range(len(values)):
  if blist[i][1]!=values[i]:
    print "ERROR at ",blist[i],values[i]

